#include "os.h"

int main()
{
    k_clear_screen();

    // GDT, IDT, ISRS, IRQ, timer, keyboard
    gdt_install();
    idt_install();
    isrs_install();
    irq_install();
    timer_install();
    keyboard_install();

	k_printf("   ************************************************", 0, 0xA);
	k_printf("   *                                              *", 1, 0xA);
	k_printf("   *          Welcome to HenkesSoft OS.           *", 2, 0xA);
	k_printf("   *                                              *", 3, 0xA);
	k_printf("   *        The C kernel has been loaded.         *", 4, 0xA);
	k_printf("   *                                              *", 5, 0xA);
	k_printf("   ************************************************", 6, 0xA);

	update_cursor(8, 0);

	/*
	unsigned char KeyGot=0;
	char bufferKEY[10];
	char bufferASCII[10];
	char bufferASCII_hex[10];
	char bufferTEST[10];

    int i;
    */

    /*TEST*/
    // i = 5/0;
    // k_itoa(i,bufferTEST);
    // k_printf(bufferKEY, 10,0xA); // TEST
    /*TEST*/

    sti();

	while(TRUE)
	{
	    int j;
        for(j=0;j<100000;++j)/*do nothing*/;

        /*TEST*/
        // i = 5/0;
        // k_itoa(i,bufferTEST);
        // k_printf(bufferKEY, 10,0xA); // TEST
        /*TEST*/

        //keyboard_handler(0);
        //KeyGot = k_getch();   // port 0x60 -> scancode + shift key -> ASCII

        /*
        bufferKEY[0] = KeyGot;
        k_itoa(KeyGot,bufferASCII);
        k_i2hex(KeyGot,bufferASCII_hex,2);
        //k_clear_screen();
        k_printf(bufferKEY,      0,0xA); // the ASCII character
        k_printf(bufferASCII,    1,0xA); // ASCII decimal
        k_printf(bufferASCII_hex,2,0xA); // ASCII hexadecimal
        */
    };

	return 0;
};
